#include "command.h"
#include <nagios/nebmods.h>
#include <string.h>

NEB_API_VERSION(CURRENT_NEB_API_VERSION);

static char *modname = "command_qh";
#define RT_ERROR(msg) \
	logit(NSLOG_RUNTIME_ERROR, TRUE, "%s: %s: %s\n", modname, msg, strerror(errno));

static int command_qh(int sd, char *query, unsigned int len) {
	int ret = QH_OK;
	char * reply = strndup(
			process_query(query, (size_t) len, process_external_command1), (size_t)4096);
	if (!reply) { /* ENOMEM, probably*/
		RT_ERROR("Failed to process request: %s\n");
		ret = QH_CLOSE;
	}
	else if ( 0 > nsock_printf_nul(sd, reply) ) {
		RT_ERROR("Failed to answer request on QH socket");
		ret = QH_CLOSE;

	}
	if (reply) free(reply);
	return ret;
}

int nebmodule_init(int /*@unused@*/ flags,
		char /*@unused@*/ *args, void /*@unused@*/ *handle) {
	return qh_register_handler("command", "Run external command", 0, command_qh);
}

int nebmodule_deinit(int /*@unused@*/ flags, int /*@unused@*/ reason) { return 0; }
