#include "command.h"
#include <string.h>
char * process_query(char *query, size_t len, int (*cmdexecfn)(char *)) {
	char *command;
	char *reply;
	int cmd_retcode = CMD_ERROR_OK;
	if ( 0  == strncmp(query, "help", len)) {
		asprintf(&reply, "Execute an external command\n"
			"run <command> Runs an external command\n");
	}

	else if ( 0 == strncmp(query, "run", (size_t)strlen("run"))){
		command = query+strlen("run");

		/*chomp whitespaces*/
		while (*command == ' ') ++command;

		if (strlen(command) < 1) {
			asprintf(&reply, "ERROR:%s\n", cmd_error_strerror(CMD_ERROR_MALFORMED_COMMAND));
		}
		else {
			cmd_retcode = cmdexecfn(command);
			if ( cmd_retcode == CMD_ERROR_OK ) {
				asprintf(&reply, "OK:%s\n", cmd_error_strerror(cmd_retcode));
			} else {
				asprintf(&reply, "ERROR:%s\n", cmd_error_strerror(cmd_retcode));
			}
		}
	}
	else {
		asprintf(&reply, "Unknown command\n");
	}

	return reply;
}
